# -*- coding: utf-8 -*-
# Generated by Django 1.11.6 on 2019-11-18 23:35
from __future__ import unicode_literals

from django.db import migrations


class Migration(migrations.Migration):

    dependencies = [
        ('providers', '0001_initial'),
    ]

    sql = """
    CREATE VIEW providers_financialrecord AS SELECT 'I' || id::text as record_id, paid AS paid, due_date AS ts, total AS charge, NULL AS credit, comment || ' (Folio: ' || folio::text || ')' AS comment, provider_id FROM providers_invoice UNION SELECT 'P' || id::text as record_id, TRUE as paid, paid_on AS ts, NULL AS charge, amount AS credit, comment, provider_id FROM providers_payment ORDER BY ts DESC
    """

    balance_sql = """
    CREATE VIEW providers_balance AS SELECT C.id as id, C.id as provider_id, COALESCE(SUM(FR.credit), 0)-COALESCE(SUM(FR.charge), 0) AS balance FROM providers_provider C LEFT JOIN providers_financialrecord FR ON C.id = FR.provider_id GROUP BY id
    """

    operations = [
        migrations.RunSQL("DROP VIEW IF EXISTS providers_balance"),
        migrations.RunSQL("DROP VIEW IF EXISTS providers_financialrecord"),
        migrations.RunSQL(sql),
        migrations.RunSQL(balance_sql)
    ]
